package com.company.mupload.web.screens.test;

import com.haulmont.cuba.core.entity.FileDescriptor;
import com.haulmont.cuba.core.entity.Entity;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.core.global.FileStorageException;
import com.haulmont.cuba.gui.Notifications;
import com.haulmont.cuba.gui.components.FileMultiUploadField;
import com.haulmont.cuba.gui.model.CollectionPropertyContainer;
import com.haulmont.cuba.gui.screen.*;
import com.company.mupload.Test;
import com.haulmont.cuba.gui.upload.FileUploadingAPI;

import javax.inject.Inject;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import java.util.UUID;


@UiController("mupload_Test.edit")
@UiDescriptor("test-edit.xml")
@EditedEntityContainer("testDc")
@LoadDataBeforeShow
public class TestEdit extends StandardEditor<Test>
{
    //Load
    @Inject
    protected CollectionPropertyContainer<FileDescriptor> fileDc;

    //System
    @Inject
    private FileMultiUploadField multiUploadField;
    @Inject
    private FileUploadingAPI fileUploadingAPI;
    @Inject
    private Notifications notifications;
    @Inject
    private DataManager dataManager;

    @Subscribe
    protected void onInitEntity(InitEntityEvent<Test> event)
    {
        if (getEditedEntity().getFile() == null)
        {
            //getEditedEntity().setFile(new ArrayList<FileDescriptor>());
        }
    }

    @Subscribe("multiUploadField")
    private void onMultiUploadFieldQueueUploadComplete(FileMultiUploadField.QueueUploadCompleteEvent event)
    {
        for (Map.Entry<UUID, String> entry : multiUploadField.getUploadsMap().entrySet())
        {
            UUID fileId = entry.getKey();
            String fileName = entry.getValue();
            FileDescriptor fd = fileUploadingAPI.getFileDescriptor(fileId, fileName);
            try {
                fileUploadingAPI.putFileIntoStorage(fileId, fd);
            } catch (FileStorageException e) {
                throw new RuntimeException("Error saving file to FileStorage", e);
            }

            fileDc.getMutableItems()
                    .add(dataManager.commit(fd));
        }

        notifications.create(Notifications.NotificationType.TRAY)
                .withCaption("Файлы загружены: " + multiUploadField.getUploadsMap().values())
                .show();
    }
}